Author : Anurag Mukkara (anurag_m@csail.mit.edu)
Date : 30 Jan 2016

Implementation of hierarchical clustering of miss curves described in
Whirlpool:Improving Dynamic Cache Management with Static Data Classification,
Anurag Mukkara, Nathan Beckmann, Daniel Sanchez, ASPLOS-21, April 2016.

See Section 4 of the paper for a brief introduction into whirltool.

Inputs:
1)Misscurves for each callpoint, in each epoch.
2)List of callpoints with each callpoint mapped to its own pool.

Output:
List of callpoints mapped to a specific number of clusters. By default, the algorithm sweeps
the number of final clusters from 2 to 8.

Files
baseScript.py
argument parsing, paths setup, simple routines used in main script.

whirltool.py
Main script that parses miss curves, calls clustering routines and generates final output.

whirltoolHelper.py
Input callpoint list parsing and final callpoint->pool mapping generation routines.

hcluster.py
Hierarchical clustering algorithm that clusters miss curves based
on miss curve distance metric.

combineMissCurves.py
Routines to convexify miss curves, to calculate combined and partitioned
miss curve of a pair of miss curves.

Usage:
See baseScript.py for arguments to whirltool.py
